#include <stdint.h>
#include <stdbool.h>
#include "kprint.h"
#include "inout.h"

#define STATUS_OUTPUTBUFFER			(1 << 0)

static uint8_t readStatus(void) {
	return inByte(0x64);
}

static uint8_t readBuffer(void) {
	return inByte(0x60);
}

static char readKeyboardKey(void) {
	uint8_t key = readBuffer();
	switch (key) {
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
			return '1' + key - 2;

		case 11:
			return '0';

		default: return 0;
	}
}

void rebootSystem(void) {
	outByte(0x64, 0xfe);
	while (true);
}

int16_t readKey(void) {
	if ((readStatus() & STATUS_OUTPUTBUFFER) != 0) {
		char key = readKeyboardKey();
		if (key != 0) {
			return key;
		}
	} 
	return -1;
}

uint8_t waitKey(void) {
	int16_t key;
	while ((key = readKey()) == -1);
	return key;
}

void initKeyboard(void) {
}
