#ifndef __KPRINTF_H__
#define __KPRINTF_H__

/*
 * kputc() is equivilant to C's putc()
 * supported non-printable ascii characters:
 *     \n    start a new line
 *     \r    carriage return (will /not/ start a new line)
 *     \t    tab space
 */
int kputc(const char c);


/*
 * kputs() is slightly different to C's puts(). It does not place a new
 * line.
 * uses kputc() so all restictions of kputc() apply
 */
int kputs(const char * str);


/*
 * kprintf() is slightly different to C's printf(). It only accepts
 * 	%d	print signed int in decimal
 * 	%u	print unsigned int in decimal
 * 	%x	print unsigned int in hex
 * 	%c	print character
 * 	%s	print string
 * uses kputc() so all restictions of kputc() apply
 */
int kprintf(const char * restrict fmt, ...);

#endif /*__KPRINTF_H__*/

