from .Block import Block

class MaximumLikelihood(object):
	def __init__(self):
		self._len = None
		self._specimen = [ ]

	def add(self, block):
		if self._len is not None:
			assert(len(block) == self._len)
		else:
			self._len = len(block)
		self._specimen.append(block.tobits())

	def estimate(self):
		mid = len(self._specimen) // 2
		result = [ ]
		for bit in zip(*self._specimen):
			cnt = sum(bit)
			if cnt <= mid:
				result.append(0)
			else:
				result.append(1)
		return Block().setfrombits(result)

if __name__ == "__main__":
	ml = MaximumLikelihood()
	ml.add(Block(b"\x00\x00\x00"))
	ml.add(Block(b"\x00\x40\x80"))
	ml.add(Block(b"\x10\x12\x00"))
	ml.add(Block(b"\x00\x12\x00"))
	ml.add(Block(b"\x00\x19\x00"))
	print(ml.estimate())
