class Sampler(object):
	def __init__(self):
		self._data = [ ]

	def add(self, data):
		self._data.append(data)

	def _getbyte(self, byteno):
		bytevalues = [ stream[byteno] for stream in self._data ]
		resultbyte = [ ]
		confidence = 1 / 16
		
		for bit in range(8):
			bitvalues = sum(((bytevalue >> bit) & 1) for bytevalue in bytevalues)
			if confidence * len(bytevalues) < bitvalues < (1 - confidence) * len(bytevalues):
				print("Poor guess: byte %d bit %d, %d/%d values confidence %.1f" % (byteno, bit, bitvalues, len(bytevalues), bitvalues / len(bytevalues)))
			if bitvalues >= len(bytevalues) // 2:
				resultbyte.append(1)
			else:
				resultbyte.append(0)
		return sum(resultbyte[i] << i for i in range(8))

	def getmaxlh(self):
		return bytes([ self._getbyte(i) for i in range(len(self._data[0])) ])

