import sys
import os

def getfilesize(filename):
	return os.stat(filename).st_size

def parseint(intstr):
	if intstr.startswith("0x"):
		return int(intstr, 16)
	else:
		return int(intstr)

def memaddr_to_fileaddr(memaddr):
	offset = ((memaddr >> 29) << 21) + 0x62800
	return memaddr - offset

def fmt4(string):
	return " ".join(string[i : i + 4] for i in range(0, len(string), 4))

def bytepartition(data, wordsize):
	assert(len(data) % wordsize == 0)
	return (data[i : i + wordsize] for i in range(0, len(data), wordsize))

#def extractbit(data, wordsize, bitno):
#	bits = [ ((bytetoint(data[i : i + wordsize]) >> bitno) & 1) for i in range(0, len(data), wordsize) ]
#	return bits

def getpoly(poly):
	coeffs = [ ]
	for (exponent, value) in enumerate(poly):
		if value == 0:
			continue

		if exponent == 0:
			coeffs.append("1")
		elif exponent == 1:
			coeffs.append("x")
		else:
			coeffs.append("x^%d" % (exponent))

	if len(coeffs) == 0:
		coeffs.append("0")
	return " + ".join(coeffs[::-1])

def polytoint(poly):
	return sum((1 << bit) for (bit, value) in enumerate(poly) if (value == 1))

def logprint(*line):
	logfile = open("logfile.txt", "a")
	print(*line, file = logfile)
	print(*line, file = sys.stderr)
	logfile.flush()
	logfile.close()

def bito(x, bitcount):
	"""Switches bitorder of the given number (i.e. most significant bit
	becomes least significant bit and vice versa)."""
	y = 0
	for i in range(bitcount):
			if (x & (1 << i)) != 0:
					y |= (1 << (bitcount - 1 - i))
	return y

def ror(x, width, bitcnt = 1):
        """Returns the result of a rotate right operation with a specified bitwidth."""
        assert(isinstance(width, int))
        assert(width >= 2)
        bitcnt = bitcnt % width
        mask = (1 << width) - 1
        x = x & mask
        for i in range(bitcnt):
                carry = x & 1
                x = (x >> 1) | (carry << (width - 1))
        return x

def rol(x, width, bitcnt = 1):
        """Returns the result of a rotate left operation with a specified bitwidth."""
        assert(isinstance(width, int))
        assert(width >= 2)
        bitcnt = bitcnt % width
        mask = (1 << width) - 1
        x = x & mask
        for i in range(bitcnt):
                carry = (x >> (width - 1)) & 1
                x = (x << 1) | carry
                x = x & mask
        return x

def parsepoly(polystr):
	exponents = [ ]
	for term in polystr.split(" + "):
		if term == "1":
			exponents.append(0)
		elif term == "x":
			exponents.append(1)
		elif term.startswith("x^"):
			exponents.append(int(term[2:]))
		else:
			raise Exception("Parse error")
	return exponents

if __name__ == "__main__":
	pass
